#pragma once
#include <QMainWindow>
#include "BehaviorPerform.h"
#include <QGraphicsItem>
#include <QGraphicsView>

class NodePresent : public QGraphicsItem {
private:
	std::shared_ptr<LogicalNode> _node_bind;

public:
	NodePresent(std::shared_ptr<LogicalNode> bind);

	QRectF contentMeasure() const;

	// ͨ QGraphicsItem ̳
	QRectF boundingRect() const override;
	void paint(QPainter* painter, const QStyleOptionGraphicsItem* option, QWidget* widget) override;
};


uint qHash(const std::shared_ptr<LogicalNode> data, uint seed) noexcept;
/// <summary>
/// Ϊ༭չʾ
/// </summary>
class BehaviorsPresent : public QGraphicsView
{
private:
	QGraphicsScene _bind_scene;

	const double _space_h = 120;
	QHash<std::shared_ptr<LogicalNode>, NodePresent*> _present_peers;

	/// <summary>
	/// Ϊڵ
	/// </summary>
	std::shared_ptr<BehaviorMapNode> _bind_maproot = nullptr;

public:
	BehaviorsPresent(QWidget* parent = nullptr);

	/// <summary>
	/// 滻Ϊ
	/// </summary>
	/// <param name="root"></param>
	void setRoot(std::shared_ptr<BehaviorMapNode> root);

	/// <summary>
	/// ʾڵ
	/// </summary>
	/// <param name="_present_peers"></param>
	/// <param name="ins"></param>
	void presentAllocate(std::shared_ptr<LogicalNode> ins);
	/// <summary>
	/// ݹͷʾڵ
	/// </summary>
	/// <param name="ins"></param>
	void presentRelease(std::shared_ptr<LogicalNode> ins);

	/// <summary>
	/// ²
	/// </summary>
	void contentRelayout();
	/// <summary>
	/// ߴ
	/// </summary>
	/// <param name="ins"></param>
	/// <param name="_outline_occupy"></param>
	/// <returns></returns>
	QSizeF outlineMeasure(std::shared_ptr<LogicalNode> ins, QHash<std::shared_ptr<LogicalNode>, std::pair<QSizeF, QSizeF>>& _outline_occupy);
	/// <summary>
	/// ڵ㲼
	/// </summary>
	/// <param name="_outline_occupy">ߴ¼</param>
	/// <param name="ins">ָڵ</param>
	/// <param name="origin_offset">Ͻ</param>
	/// <returns>½</returns>
	QPointF nodeRelayout(QHash<std::shared_ptr<LogicalNode>, std::pair<QSizeF, QSizeF>>& _outline_occupy,
		std::shared_ptr<LogicalNode> ins, const QPointF &origin_offset);
};

